  //		Includes
 //
//
#include <stdio.h>
#include <USBKit.h>
#include <Path.h>
#include <FindDirectory.h>


  //		Local includes
 //
//
#include "prototypes.h"
#include "picitem.h"
#include "app.h"
#include "mainwin.h"
#include "exifparse.h"
#include "about.h"
#include "setattrwin.h"
#include "camerainfowin.h"
#include "statuswin.h"
#include "filepanel.h"


  //		External variables
 //
//
extern class ixd_App		*app;
extern unsigned char 		flashdevice[];





 //		USB Roster class
//
class Roster : public USBRoster
{
public:
virtual status_t DeviceAdded(USBDevice *dev)
	{
	if(ixus_init(dev, true))
		{
// test of dev/roster
		app->dev=dev;
		strcpy(app->devname, "/dev/bus/usb");
		strcpy(app->devname+12, dev->Location());
//		return(B_ERROR);
		}
	else
		{
		}
	return(B_OK);
	}

virtual void DeviceRemoved(USBDevice *dev)
	{
	fprintf(stderr, "\nDevice Removed.\n");
// test of dev/roster
	if(app->dev==dev)
		{
		app->dev=NULL;
//		err_req("The camera was disconnected");
		}
	}
private:
};


  //		ixd_App::ixd_App
 //
//
ixd_App::ixd_App() : BApplication("application/x-vnd.ubbe-ixusdownload")
{
setattr_Win	=	NULL;
aboutwindow	=	NULL;
status_Win	=	NULL;
camerainfo_Win=	NULL;
filepanel	=	NULL;
dev			=	NULL;
cameraname[0]=0;
ownername[0]=0;
totalbytes=freebytes=0;
powerstatus=0;
}


  //	ixd_App::ReadyToRum
 //
//
void ixd_App::ReadyToRun()
{
BWindow		*panel_Win;

	main_Win = new ixd_mainWin();

	roster= new Roster;

	main_Win->Show();
	roster->Start();

	filepanel=new ixd_FilePanel(&be_app_messenger);

	if(filepanel)
		{
		}
//
	uploadpanel=new BFilePanel(
							B_OPEN_PANEL,					// mode
							NULL,							// target
							NULL,							// panel_directory
							B_FILE_NODE,					// node_flavors
							false,							// allow_multiple_selection
							new BMessage(UPLOAD_MSG),		// message
							NULL,							// filter
							true,							// modal
							true							// hide_when_done
							);

	if(uploadpanel)
		{
		uploadpanel->SetButtonLabel(B_DEFAULT_BUTTON, "Select");

		panel_Win=uploadpanel->Window();
		
		panel_Win->SetTitle("ixusdownload : select file");
		}
}


  //		ixd_App::AboutRequested
 //
//
void ixd_App::AboutRequested(void)
{
	if(!aboutwindow)
		{
		aboutwindow = new ixd_aboutWin();
		aboutwindow->Show();
		}
	else
		{
		aboutwindow->Activate(TRUE);
		}
}


  //		ixd_App::RefsReceived
 //
//
void ixd_App::RefsReceived(BMessage *message)
{
entry_ref		ref;
FILE			*fh;

	switch(message->what)
		{
		case B_REFS_RECEIVED:
		if(message->FindRef("refs", &ref) == B_OK)
			{
			BEntry		bent(&ref, true);
			BPath		path;
			
			bent.GetPath(&path);
			chdir(path.Path());
			app->Download_Selected();

			BPath		path_obj;
			
			if(find_directory(B_USER_SETTINGS_DIRECTORY, &path_obj) == B_OK)
				{
				path_obj.Append("x-vnd.ubbe-ixusdownload");

				if((fh=fopen(path_obj.Path(), "w")))
					{
					fprintf(fh, "%s\n", path.Path());
					fclose(fh);
					}
				}
			}
 		break;

		default:
			BApplication::RefsReceived(message);
		}
}


  //		ixd_App::MessageReceived
 //
//
void ixd_App::MessageReceived(BMessage* message)
{
entry_ref		ref;
FILE			*fh;

	switch(message->what)
		{
		case 'slct':
		app->filepanel->Hide();
		if(message->FindRef("refs", &ref) == B_OK)
			{
			BEntry		bent(&ref, true);
			BPath		path;
			
			bent.GetPath(&path);
			chdir(path.Path());
			app->Download_Selected();

			BPath		path_obj;
			
			if(find_directory(B_USER_SETTINGS_DIRECTORY, &path_obj) == B_OK)
				{
				path_obj.Append("x-vnd.ubbe-ixusdownload");

				if((fh=fopen(path_obj.Path(), "w")))
					{
					fprintf(fh, "%s\n", path.Path());
					fclose(fh);
					}
				}
			}
		break;
		
		case B_CANCEL:
		break;

		case B_SAVE_REQUESTED:
		break;

		case UPLOAD_MSG:
		if(message->FindRef("refs", &ref) == B_OK)
			{
			BEntry		bent(&ref, true);
			BPath		path;

			bent.GetPath(&path);

//err_req((char *)path.Path());

			if(app->OpenCamera())
				{
				ixus_sendfile(app->dev, app->buf, path.Path());

/*				if((dirent=ixus_getdir(dev, app->buf, ixus_flashdevice(dev, app->buf))))
					{
					app->clear_list();
					ixus_getthumbs(dev, app->buf, dirent);
					ixus_freedir(dirent);
					}
*/
				app->CloseCamera();
				}	

			}
		break;

		default:
			BApplication::MessageReceived(message);
		}
}


  //		ixd_App::Download
 //
//
bool ixd_App::Download(class pic_Item *item)
{
if(OpenCamera())
	{
	fprintf(stderr, "\nDownload %s\n", item->GetName());
	if(ixus_getfile(dev, buf, (unsigned char *)item->GetName(), item))
		{
		if(ixus_setattr(dev, buf, (unsigned char *)item->GetName(), item->pic_Attrs & 223))
			{
			app->main_Win->Lock();
			item->pic_Attrs &= 223;
			app->main_Win->update_item(item);
			app->main_Win->Unlock();
			}
		CloseCamera();
		return(true);
		}
	CloseCamera();
	}
else
	{
	err_req("Download: Could not open USB device");
	}
return(false);
}


  //		ixd_App::Setattr
 //
//
bool ixd_App::Setattr(class pic_Item *item, uint32 attrs)
{
if(OpenCamera())
	{
	if(ixus_setattr(dev, buf, (unsigned char *)item->GetName(), attrs))
		{
		app->main_Win->Lock();
		item->pic_Attrs = attrs;
		app->main_Win->update_item(item);
		app->main_Win->Unlock();
		}
	CloseCamera();
	}
else
	{
	err_req("Setattr: Could not open USB device");
	}
return(false);
}


  //		ixd_App::Deletepic
 //
//
bool ixd_App::Deletepic(const char *name)
{
if(OpenCamera())
	{
	fprintf(stderr, "\nDelete %s\n", name);
	if(ixus_delete(dev, buf, (unsigned char *)name) != IXDEL_OK)
		{
		CloseCamera();
		return(false);
		}
	CloseCamera();
	return(true);
	}
else
	{
	err_req("Delete: Could not open USB device");
	}
return(false);
}


  //		dev/roster version OpenCamera()
 //
//
class USBDevice *ixd_App::OpenCamera()
{
if(dev)
	{
	if(dev->InitCheck() || dev->SetConfiguration(dev->ConfigurationAt(0)))
		{
		return(NULL);
		}
	}
return(dev);
}


  //		dev/roster version CloseCamera()
 //
//
void ixd_App::CloseCamera()
{
if(dev)
	{
	}
}


  //		ixd_App::add_item
 //
//
void			ixd_App::add_item(class pic_Item *item)
					{
					main_Win->add_item(item);
					}


  //		ixd_App::clear_list
 //
//
void			ixd_App::clear_list(void)
					{
					main_Win->clear_list();
					}


  //		ixd_App::sort_list
 //
//
void			ixd_App::sort_list(void)
					{
					main_Win->sort_list();
					}


  //		ixd_App::Download_Selected
 //
//
void			ixd_App::Download_Selected(void)
					{
					return main_Win->Download_Selected();
					}


  //		ixd_App::SelectAll
 //
//
void			ixd_App::SelectAll(void)
					{
					return main_Win->SelectAll();
					}


  //		ixd_App::SelectNew
 //
//
void			ixd_App::SelectNew(void)
					{
					return main_Win->SelectNew();
					}


  //		ixd_App::opensetattr
 //
//
void			ixd_App::opensetattr(void)
					{
					if(! app->setattr_Win)
						{
						app->setattr_Win = new ixd_setattrWin();
						}
					setattr_Win->Show();
					}


  //		ixd_App::opencamerainfo
 //
//
void			ixd_App::opencamerainfo(void)
					{
					if(OpenCamera())
						{
						ixus_identify(dev, buf);
						ixus_diskinfo(dev, buf, (const char *)flashdevice);
						ixus_powerinfo(dev, buf);
						if(! app->camerainfo_Win)
							{
							app->camerainfo_Win = new ixd_camerainfoWin();
							}
						else
							{
							app->camerainfo_Win->Activate(TRUE);
							}
						camerainfo_Win->Show();
						CloseCamera();
						}
					}


  //		ixd_App::setownername
 //
//
void			ixd_App::setownername(const char *owner)
					{
					if(OpenCamera())
						{
						ixus_setowner(dev, buf, owner);
						CloseCamera();
						}
					}


  //		ixd_App::openstatus
 //
//
void			ixd_App::openstatus(int32 totalbytes, char *message)
					{
					if(! app->status_Win)
						{
						app->status_Win = new ixd_statusWin(totalbytes, message);
						}
					status_Win->reset(totalbytes);
					status_Win->Show();
					}


  //		ixd_App::closestatus
 //
//
void			ixd_App::closestatus(void)
					{
					if(app->status_Win)
						{
						status_Win->Hide();
						}
					}


  //		ixd_App::updatestatus
 //
//
void			ixd_App::updatestatus(uint32 delta, char *message)
					{
					if(status_Win)
						{
						status_Win->updatestatus(delta, message);
						}
					}


  //		ixd_App::Setattr_Selected
 //
//
void			ixd_App::Setattr_Selected(char dwn, char prt)
					{
					main_Win->Setattr_Selected(dwn, prt);
					}
