  //		Includes
 //
//
#include <stdio.h>
#include <SupportKit.h>
#include <ScrollView.h>
#include <Button.h>
#include <StringView.h>
#include <TextView.h>
#include <Box.h>


  //		Local includes
 //
//
#include "app.h"
#include "camerainfowin.h"
#include "prototypes.h"
#include "cameracommands.h"


  //		External variables
 //
//
extern class ixd_App		*app;


  //		ixd_camerainfoWin::QuitRequested
 //
//
bool ixd_camerainfoWin::QuitRequested()
{
	app->camerainfo_Win=NULL;
	return BWindow::QuitRequested();
}

//	ixd_camerainfoWin::MessageRecieved
void ixd_camerainfoWin::MessageReceived(BMessage* message)
{
switch(message->what)
	{
	case SET_OWNER:
		app->setownername(ownertextview->Text());
		strncpy(app->ownername, ownertextview->Text(), 32);
	break;

	default:
		BWindow::MessageReceived(message);
	}
}


  //		ixd_camerainfoWin::Update
 //
//
void ixd_camerainfoWin::Update(void)
{
char	tmps[100];

	Lock();
	camerastringview->SetText(app->cameraname);
	ownertextview->SetText(app->ownername);
	sprintf(tmps, "%ld bytes free / %ld bytes total", app->freebytes, app->totalbytes);
	bytesstringview->SetText(tmps);
	sprintf(tmps, "power status: %s, running on %s", (app->powerstatus & 1)?"critical":"ok", (app->powerstatus & 2)?"AC adaptor":"battery");
	powerstringview->SetText(tmps);
	Unlock();
}


  //		ixd_camerainfoWin  -  Constructor
 //
//
ixd_camerainfoWin::ixd_camerainfoWin() : BWindow(BRect(100,100,370,245), "ixusdownload camera info", B_TITLED_WINDOW, B_WILL_DRAW | B_NOT_RESIZABLE)
{
BRect	r, tr;
char	tmps[100];

	r=Bounds();
	
	view = new BView(
						r,
						"ixd_ciview",
						B_FOLLOW_LEFT_RIGHT,
						0
						);

	rgb_color bg_color=ui_color(B_PANEL_BACKGROUND_COLOR);
	view->SetViewColor(bg_color);
	
	r.top=5;
	r.left=5;
	r.right-=5;
	r.bottom=r.top+20;

	camerastringview = new	BStringView(
							r,
							"cstview",
							app->cameraname,
							B_FOLLOW_LEFT | B_FOLLOW_TOP,
							B_WILL_DRAW
							);



	r.top=r.bottom+5;
	r.left=5;
	r.right-=5;
	r.bottom=r.top+20;

	sprintf(tmps, "%ld bytes free / %ld bytes total", app->freebytes, app->totalbytes);

	bytesstringview = new	BStringView(
							r,
							"bytesview",
							tmps,
							B_FOLLOW_LEFT | B_FOLLOW_TOP,
							B_WILL_DRAW
							);


	r.top=r.bottom+5;
	r.left=5;
	r.right-=5;
	r.bottom=r.top+20;

	sprintf(tmps, "power status: %s, running on %s", (app->powerstatus & 1)?"critical":"ok",
						 (app->powerstatus & 2)?"AC adaptor":"battery"
						 );

	powerstringview = new	BStringView(
							r,
							"powerview",
							tmps,
							B_FOLLOW_LEFT | B_FOLLOW_TOP,
							B_WILL_DRAW
							);

	tr=Bounds();

	r.top=r.bottom+20;
	r.left=5;
	r.right=tr.right-5;
	r.bottom=r.top+40;

	ownerbox = new BBox(
						r,
						"ownerbox",
						B_FOLLOW_LEFT_RIGHT
						);

	ownerbox->SetLabel("Camera owner");

	tr=ownerbox->Bounds();
	tr.top+=15;
	tr.bottom-=6;
	tr.left+=5;
	tr.right-=50;
	ownertextview =	new BTextView(
							tr,
							"owntext",
							BRect(2, 5, tr.right-2, 15),
							B_FOLLOW_LEFT | B_FOLLOW_TOP,
							B_WILL_DRAW
							);

	ownertextview->SetMaxBytes(180);
	ownertextview->SetWordWrap(false);
	ownertextview->MakeResizable(false);
	ownertextview->DisallowChar('\n');
	ownertextview->SetText(app->ownername);

	otscrollview = new BScrollView(
									"ot_scroll",
									ownertextview,
									B_FOLLOW_ALL_SIDES,
									B_WILL_DRAW | B_FRAME_EVENTS,
									false,
									false,
									B_FANCY_BORDER
									);
	tr.top-=3;
	tr.left=tr.right+5;
	tr.right=tr.left+40;

	setownerbutton = new BButton(
							tr,
							"setownbut",
							"Set", 
							new BMessage(SET_OWNER),
							B_FOLLOW_BOTTOM,
							B_WILL_DRAW | B_NAVIGABLE
							);

	ownerbox->AddChild(otscrollview);
	ownerbox->AddChild(setownerbutton);
	view->AddChild(ownerbox);
	view->AddChild(camerastringview);
	view->AddChild(bytesstringview);
	view->AddChild(powerstringview);
	AddChild(view);
}


