  //		Includes
 //
//
#include <stdio.h>
#include <ScrollView.h>
#include <Button.h>
#include <Alert.h>
#include <Path.h>
#include <MenuBar.h>
#include <Menu.h>
#include <MenuItem.h>
#include <FindDirectory.h>


  //		Local includes
 //
//
#include "prototypes.h"
#include "picitem.h"
#include "app.h"
#include "exifparse.h"
#include "about.h"
#include "setattrwin.h"
#include "camerainfowin.h"
#include "mainwin.h"
#include "filepanel.h"


  //		External variables
 //
//
extern class ixd_App		*app;
extern unsigned char 		flashdevice[];




  //		ixd_mainWin::QuitRequested
 //
//
bool ixd_mainWin::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return BWindow::QuitRequested();
}


  //		ixd_MainWin::MessageRecieved
 //
//
void ixd_mainWin::MessageReceived(BMessage* message)
{
class pic_Item		*item;
int32				selected, i=0, tmp;
char				namebuf[B_PATH_NAME_LENGTH];
FILE				*fh;

	switch(message->what)
		{
		case ATTR_BUTTON:
		if((ixd_listview->CurrentSelection(0)) >= 0)
			{
			app->opensetattr();
			}
		break;

		case ROTATE_RIGHT_MSG:
		Rotate_Selected(90);
		break;

		case ROTATE_LEFT_MSG:
		Rotate_Selected(270);
		break;

		case DOWN_BUTTON:
		if((ixd_listview->CurrentSelection(0)) >= 0)
			{
			BPath		path_obj;
			
			if(find_directory(B_USER_SETTINGS_DIRECTORY, &path_obj) == B_OK)
				{
				path_obj.Append("x-vnd.ubbe-ixusdownload");

				if((fh=fopen(path_obj.Path(), "r")))
					{
					fgets(namebuf, B_PATH_NAME_LENGTH, fh);
					fclose(fh);
					tmp=strlen(namebuf);
					namebuf[(tmp?tmp-1:0)]=0;				
					app->filepanel->SetPanelDirectory(namebuf);
					}
				}
			app->filepanel->Show();
			}
		break;

		case UP_BUTTON:
		app->uploadpanel->Show();
		break;

		case DEL_BUTTON:
		if((ixd_listview->CurrentSelection(0)) >= 0)
			{
			BAlert *myAlert = new BAlert("ixusdownload error", "Do you really want to delete?",	"Ok", "Cancel", NULL, B_WIDTH_AS_USUAL,
							B_OFFSET_SPACING, B_WARNING_ALERT);
							
			if(!myAlert)
				return;

			myAlert->SetShortcut(1, B_ESCAPE); 

			if(myAlert->Go())
				{
				return;
				}

			while( (selected = ixd_listview->CurrentSelection(i)) >= 0 )
				{
				item = (class pic_Item *)ixd_listview->ItemAt(selected);
				if(item->Deletable())
					{
					if(app->Deletepic(item->GetName()))
						{
						remove_item(item);
						}
					else
						{
						break;
						}
					}
				else
					{
					i++;
					}

				if(app->OpenCamera())
					{
					ixus_identify(app->dev, app->buf);
					ixus_diskinfo(app->dev, app->buf, (const char *)flashdevice);
					ixus_powerinfo(app->dev, app->buf);
					if(app->camerainfo_Win)
						{
						app->camerainfo_Win->Update();
						}
					app->CloseCamera();
					}
				}
			}
		break;

		case ABOUT:
		app->AboutRequested();
		break;

		case QUIT:
		be_app->PostMessage(B_QUIT_REQUESTED);
		break;

		case SELECT_ALL:
		app->SelectAll();
		break;

		case SELECT_NEW:
		app->SelectNew();
		break;

		case CAMERA_INFO:
		app->opencamerainfo();
		break;

		default:
			BWindow::MessageReceived(message);
		}
}



  //		ixd_mainWin::Setattr_Selected
 //
//
void ixd_mainWin::Setattr_Selected(char dwn, char prt)
{
class pic_Item		*item;
int32				selected, i=0, tmp;

while( (selected = ixd_listview->CurrentSelection(i)) >= 0 )
	{
	item = (class pic_Item *)ixd_listview->ItemAt(selected);
	tmp=item->pic_Attrs;
	// 0==ignore, 1==unset, 2==set
	if(prt)
		{
		tmp |= (prt==2?1:0);		// set bit
		tmp &= (prt==2?255:254);	// unset bit
		}
	if(dwn)
		{
		tmp |= (dwn==2?0:32);			// set bit
		tmp &= (dwn==2?(255-32):255);	// unset bit
		}

//	fprintf(stderr, "%d %d before: %5lx after: %5lx.\n", prt, dwn, item->pic_Attrs, tmp);

	if(app->Setattr(item, tmp))
		{
		}
	i++;
	}
}


  //		ixd_mainWin::Rotate_Selected
 //
//
void ixd_mainWin::Rotate_Selected(int angle)
{
class pic_Item		*item;
int32				selected, i;

for(i=0; (selected = ixd_listview->CurrentSelection(i)) >= 0; i++)
	{
	item = (class pic_Item *)ixd_listview->ItemAt(selected);
	if(angle==90)
		{
		if(item->pic_Orientation==1)
			{
			item->set_Orientation(6);  
			}
		else if(item->pic_Orientation==6)
			{
			item->set_Orientation(7);  
			}
		else if(item->pic_Orientation==7)
			{
			item->set_Orientation(8);  
			}
		else if(item->pic_Orientation==8)
			{
			item->set_Orientation(1);  
			}
		}
	else if(angle==270)
		{
		if(item->pic_Orientation==1)
			{
			item->set_Orientation(8);  
			}
		else if(item->pic_Orientation==6)
			{
			item->set_Orientation(1);  
			}
		else if(item->pic_Orientation==7)
			{
			item->set_Orientation(6);  
			}
		else if(item->pic_Orientation==8)
			{
			item->set_Orientation(7);  
			}
		}
	
	item->Rotate(angle);
	}
	
ixd_listview->Invalidate();
}


  //		ixd_mainWin::Download_Selected
 //
//
void ixd_mainWin::Download_Selected(void)
{
class pic_Item		*item;
int32				selected, i=0, totalpics=0, totalbytes=0;
char				buf[100];

while( (selected = ixd_listview->CurrentSelection(totalpics)) >= 0 )
	{
	item = (class pic_Item *)ixd_listview->ItemAt(selected);
	totalbytes+=item->pic_Size;
	totalpics++;
	}
i=0;
sprintf(buf, "Downloading %ld of %ld", i+1, totalpics);
app->openstatus(totalbytes, buf);
app->updatestatus(0, buf);

while( (selected = ixd_listview->CurrentSelection(i)) >= 0 )
	{
	item = (class pic_Item *)ixd_listview->ItemAt(selected);
	sprintf(buf, "Downloading %ld of %ld", i+1, totalpics);
	app->updatestatus(0, buf);
	if(app->Download(item))
		{
		}
	else
		{
		app->closestatus();
		return;
		}
	i++;
	}
app->closestatus();
}


  //		ixd_MainWin  -  Constructor
 //
//
ixd_mainWin::ixd_mainWin() : BWindow(BRect(100,100,500,400), "ixusdownload", B_TITLED_WINDOW, B_WILL_DRAW)
{
	BRect r;
	BMenu *menu;
	
	// Add the menu bar
	r = Bounds();
	menubar = new BMenuBar(r, "menu_bar");
	AddChild(menubar);

	// Add File menu to menu bar
	menu = new BMenu("File");
	menu->AddItem(new BMenuItem("Download"B_UTF8_ELLIPSIS , new BMessage(DOWN_BUTTON), 'S'));
//	menu->AddItem(new BMenuItem("Upload"B_UTF8_ELLIPSIS , new BMessage(UP_BUTTON), 'U'));
	menu->AddItem(new BMenuItem("Set attributes"B_UTF8_ELLIPSIS , new BMessage(ATTR_BUTTON)));
	menu->AddSeparatorItem();
	menu->AddItem(new BMenuItem("Rotate right" , new BMessage(ROTATE_RIGHT_MSG), 'R'));
	menu->AddItem(new BMenuItem("Rotate Left" , new BMessage(ROTATE_LEFT_MSG), 'L'));
	menu->AddSeparatorItem();
	menu->AddItem(new BMenuItem("Delete"B_UTF8_ELLIPSIS , new BMessage(DEL_BUTTON)));
	menu->AddSeparatorItem();
	menu->AddItem(new BMenuItem("About ixusdownload"B_UTF8_ELLIPSIS , new BMessage(ABOUT)));
	menu->AddSeparatorItem();
	menu->AddItem(new BMenuItem("Quit", new BMessage(QUIT), 'Q'));
	menubar->AddItem(menu);

	// Add Edit menu to menu bar
	menu = new BMenu("Edit");
	menu->AddItem(new BMenuItem("Select All", new BMessage(SELECT_ALL), 'A'));
	menu->AddItem(new BMenuItem("Select New", new BMessage(SELECT_NEW), 'N'));
	menu->AddSeparatorItem();
	menu->AddItem(new BMenuItem("Camera info"B_UTF8_ELLIPSIS, new BMessage(CAMERA_INFO), 'I'));
	menubar->AddItem(menu);
	
	// Add the drawing view
	
	r.top = menubar->Bounds().bottom+1;

	ixd_view = new BView(
						r, //kViewFrame,
						"ixd_view",
						B_FOLLOW_ALL_SIDES,
						0 // B_WILL_DRAW | B_FRAME_EVENTS | B_FULL_UPDATE_ON_RESIZE
						);

	rgb_color bg_color=ui_color(B_PANEL_BACKGROUND_COLOR);
	ixd_view->SetViewColor(bg_color);

	r.top=5;
	r.left=5;
	r.right-=20;
	r.bottom=r.bottom-40-menubar->Bounds().bottom;

	ixd_listview = new BListView(
								r, //kListViewFrame,
								"ixd_listview",
								B_MULTIPLE_SELECTION_LIST,
								B_FOLLOW_ALL_SIDES,
								B_WILL_DRAW | B_NAVIGABLE | B_FRAME_EVENTS
								);

	ixd_scrollview = new BScrollView(
									"ixd_scrollview",
									ixd_listview,
									B_FOLLOW_ALL_SIDES,
									B_WILL_DRAW | B_FRAME_EVENTS,
									false,
									true,
									B_FANCY_BORDER
									);

	r.top=r.bottom+10;
	r.left=5;
	r.right=100;
	r.bottom=r.bottom+20;

	ixd_downloadbutton = new BButton(
									r, //kdownbutFrame,
									"downbut",
									"Download", 
									new BMessage(DOWN_BUTTON),
									B_FOLLOW_BOTTOM,
									B_WILL_DRAW | B_NAVIGABLE
									);

	r.left+=105;
	r.right+=105;
	ixd_deletebutton = new BButton(
									r, //kdelbutFrame,
									"delbut",
									"Delete", 
									new BMessage(DEL_BUTTON),
									B_FOLLOW_BOTTOM,
									B_WILL_DRAW | B_NAVIGABLE
									);

	r.left+=105;
	r.right+=105;
	ixd_attrbutton = new BButton(
									r, //kattrbutFrame,
									"attrbut",
									"Setattr", 
									new BMessage(ATTR_BUTTON),
									B_FOLLOW_BOTTOM,
									B_WILL_DRAW | B_NAVIGABLE
									);

	ixd_view->AddChild(ixd_scrollview);
	ixd_view->AddChild(ixd_downloadbutton);
	ixd_view->AddChild(ixd_deletebutton);
	ixd_view->AddChild(ixd_attrbutton);

	AddChild(ixd_view);

	SetSizeLimits(400, 800, 300, 1000);
}


  //
 //
//
void ixd_mainWin::add_item(class pic_Item *item)
{
Lock();
ixd_listview->AddItem(item);
Unlock();
}


  //
 //
//
void			ixd_mainWin::clear_list(void)
{
class BListItem *item;

Lock();
while(ixd_listview->CountItems())
	{
	if((item=ixd_listview->RemoveItem((int32)0)))
		{
		delete item;
		}
	}
Unlock();
}


  //
 //
//
void ixd_mainWin::sort_list(void)
{
Lock();
ixd_listview->SortItems((int (*)(const void *, const void *))&pic_compareFunc);
Unlock();
}


  //
 //
//
void ixd_mainWin::remove_item(class pic_Item *item)
{
Lock();
ixd_listview->RemoveItem(item);
delete item;
Unlock();
}


  //
 //
//
void ixd_mainWin::update_item(class pic_Item *item)
{
ixd_listview->InvalidateItem(ixd_listview->IndexOf(item));
}
void			ixd_mainWin::SelectAll(void)
{
int32	numitems;
Lock();
if((numitems=ixd_listview->CountItems()))
	{
	ixd_listview->Select(0, numitems-1, TRUE);
	}
Unlock();
}


  //
 //
//
void ixd_mainWin::SelectNew(void)
{
int32	numitems;
pic_Item	*item;

Lock();
ixd_listview->DeselectAll();
if((numitems=ixd_listview->CountItems()))
	{
	while(numitems)
		{
		numitems--;
		item=(class pic_Item *)ixd_listview->ItemAt(numitems);
		if(item->pic_Attrs & 32)
			{
			ixd_listview->Select(numitems, (bool)TRUE);
			}
		}
	}
Unlock();
}
