  //		Includes
 //
//
#include <stdio.h>

  //		Local includes
 //
//
#include "picitem.h"


  //		pic_Item
 //
//
pic_Item::pic_Item(char *name, uint32 attrs, uint32 size, uint32 date, BBitmap *bitmap, uint32 Xres, uint32 Yres) : BListItem()
{
	pic_Name=name;
	pic_Bitmap=bitmap;
	pic_Attrs=attrs;
	pic_Size=size;
	pic_Date=date;
	pic_Xres=Xres;
	pic_Yres=Yres;
	
}


  //		pic_Item destructor
 //
//
pic_Item::~pic_Item(void)
{
if(pic_Bitmap)
	{
	delete pic_Bitmap;
	}
}


  //		pic_Item::DrawItem
 //
//
void pic_Item::DrawItem(BView *owner, BRect frame, bool complete) 
{
rgb_color color;

rgb_color k_select={0xee, 0xee, 0xff, 0xff};
rgb_color kt_ena={0xff, 0x00, 0x00, 0xff};
rgb_color kt_dis={0x77, 0x00, 0x00, 0xff};
//rgb_color kt_gray={0x50, 0x50, 0x50, 0xff};
//rgb_color black_color={0x00, 0x00, 0x00, 0xff};
rgb_color kt_bg=owner->ViewColor();
/*
rgb_color k_select=ui_color(B_MENU_SELECTION_BACKGROUND_COLOR);
rgb_color kt_ena=ui_color(B_MENU_SELECTED_ITEM_TEXT_COLOR);
rgb_color kt_dis=ui_color(B_MENU_ITEM_TEXT_COLOR);
rgb_color kt_bg=ui_color(B_MENU_BACKGROUND_COLOR);
*/
BRect	rect;
font_height height;
float	fheight;
char	tmps[40];

owner->GetFontHeight(&height);
fheight=(height.ascent+height.descent);

if (IsSelected() || complete)
	{
	if(IsSelected())
		{
		color = k_select;
		}
	else
		{
		color =  kt_bg;
		}
	owner->SetHighColor(color);
	owner->SetLowColor(color);
	owner->FillRect(frame);
//owner->SetHighColor(black_color);
//owner->StrokeRect(BRect(frame.left+2, frame.top+2, frame.right-2, frame.bottom-2));
//owner->StrokeRect(BRect(frame.left+3, frame.top+3, frame.right-3, frame.bottom-3));
	}

if (IsEnabled())
	{
	owner->SetHighColor(kt_ena);
	}
else
	{
	owner->SetHighColor(kt_dis);
	}

if(pic_Bitmap)
	{
	rect=pic_Bitmap->Bounds();

	if(rect.right<rect.bottom)
		{
		rect.right=rect.bottom;
		}
	}
else
	{
	rect.left=0;
	rect.right=159;
	rect.top=0;
	rect.bottom=119;
	}

owner->MovePenTo(frame.left+rect.right+10, frame.top+(fheight));
owner->DrawString(pic_Name.String());

char *orient[10]={"", "(Landscape)", "", "", "", "", "(Portrait)", "(Landscape)", "(Portrait)", ""};

if((pic_Orientation==6) || (pic_Orientation==8))
	{
	sprintf(tmps, "%ld*%ld pixels %ld bytes.", pic_Yres, pic_Xres, pic_Size);
	}
else
	{
	sprintf(tmps, "%ld*%ld pixels %ld bytes.", pic_Xres, pic_Yres, pic_Size);
	}
owner->MovePenTo(frame.left+rect.right+10, frame.top+(fheight*2));
owner->DrawString(tmps);

sprintf(tmps, "%s %s", pic_Flash?"(Flash)":"(No flash)", orient[pic_Orientation<10?pic_Orientation:0]);
owner->MovePenTo(frame.left+rect.right+10, frame.top+(fheight*3));
owner->DrawString(tmps);

sprintf(tmps, "%s", asctime(gmtime((const time_t *)&pic_Date)));
tmps[strlen(tmps)-1]=0;
owner->MovePenTo(frame.left+rect.right+10, frame.top+(fheight*4));
owner->DrawString(tmps);

sprintf(tmps, "%s", (pic_Attrs&32)?"New picture":"Downloaded");
owner->MovePenTo(frame.left+rect.right+10, frame.top+(fheight*5));
owner->DrawString(tmps);

sprintf(tmps, "%s", (pic_Attrs&1)?"Delete protected.":"");
owner->MovePenTo(frame.left+rect.right+10, frame.top+(fheight*6));
owner->DrawString(tmps);

owner->MovePenTo(frame.left+4, frame.top+4);
if(pic_Bitmap)
	{
	owner->DrawBitmap(pic_Bitmap);
	}
else
	{
	owner->MovePenTo(frame.left+10+40, frame.top+(60+(fheight/2)));
	owner->DrawString("No thumbnail");
	}

}


  //	pic_Item::Update
 //
//
void pic_Item::Update(BView *owner, const BFont *font)
{
BRect	rect;

if(pic_Bitmap)
	{
	rect=pic_Bitmap->Bounds();
	SetHeight((rect.bottom)+8);
	}
else
	{
	SetHeight((119)+8);
	}
}


  //		pic_compareFunc(
 //
//
int pic_compareFunc(const pic_Item **one, const pic_Item **two)
{
if((*one)->pic_Date < (*two)->pic_Date)
	{
	return(1);
	}
else
if((*one)->pic_Date > (*two)->pic_Date)
	{
	return(-1);
	}
else
	{
	return(0);
	}
}


  //		pic_Item::Rotate
 //
//
void pic_Item::Rotate(int angle)
{
BRect 			tmprect, bounds;
BBitmap			*tmpbitmap;
unsigned char	*srcbits, *dstbits;
uint32			srow, drow, scol, dcol;
uint32			swidth, dwidth, sheight, dheight;
uint32			sbprow, dbprow, sbppix, dbppix;

if(pic_Bitmap)
	{
	tmprect=pic_Bitmap->Bounds();
	}
else
	{
	return;
	}
bounds.left=tmprect.left;
bounds.right=tmprect.bottom;//max(tmprect.bottom, tmprect.right);
bounds.top=tmprect.top;
bounds.bottom=tmprect.right;//max(tmprect.right, tmprect.bottom);

swidth=(uint32)tmprect.right;
sheight=(uint32)tmprect.bottom;
dwidth=(uint32)bounds.right;
dheight=(uint32)bounds.bottom;

		
if(!(tmpbitmap = new BBitmap(bounds, pic_Bitmap->ColorSpace())))
	{
	return;
	}

srcbits=(unsigned char *)pic_Bitmap->Bits();
dstbits=(unsigned char *)tmpbitmap->Bits();
sbprow=pic_Bitmap->BytesPerRow();
dbprow=tmpbitmap->BytesPerRow();
		
// assume that bytes per pixel is 4 (RGBA) - should check against colorspace
dbppix=4;
sbppix=4;

// flip to the right
if(angle==90)
	{
	for(srow=0, dcol=dwidth; srow<=sheight; srow++, dcol--)
		{
		for(scol=0, drow=0; scol<=swidth; scol++, drow++)
			{
			// should loop for [bytes per pixel] iterations instead of hardcoded to 4 bytes
			dstbits[(dbprow*drow)+(dcol*dbppix)+0]=srcbits[(sbprow*srow)+(scol*sbppix)+0];
			dstbits[(dbprow*drow)+(dcol*dbppix)+1]=srcbits[(sbprow*srow)+(scol*sbppix)+1];
			dstbits[(dbprow*drow)+(dcol*dbppix)+2]=srcbits[(sbprow*srow)+(scol*sbppix)+2];
			dstbits[(dbprow*drow)+(dcol*dbppix)+3]=srcbits[(sbprow*srow)+(scol*sbppix)+3];
			}
		}
	}

// flip to the left
if(angle==270)
	{
	for(srow=0, dcol=0; srow<=sheight; srow++, dcol++)
		{
		for(scol=0, drow=dheight; scol<=swidth; scol++, drow--)
			{
			// should loop for [bytes per pixel] iterations instead of hardcoded to 4 bytes
			dstbits[(dbprow*drow)+(dcol*dbppix)+0]=srcbits[(sbprow*srow)+(scol*sbppix)+0];
			dstbits[(dbprow*drow)+(dcol*dbppix)+1]=srcbits[(sbprow*srow)+(scol*sbppix)+1];
			dstbits[(dbprow*drow)+(dcol*dbppix)+2]=srcbits[(sbprow*srow)+(scol*sbppix)+2];
			dstbits[(dbprow*drow)+(dcol*dbppix)+3]=srcbits[(sbprow*srow)+(scol*sbppix)+3];
			}
		}
	}

// done flipping, make the change
	{
	BRect	rect;

	set_Bitmap(tmpbitmap);
	rect=pic_Bitmap->Bounds();
	SetHeight((rect.bottom)+8);
	}
}
